$tainted char *getenv(const char *name);
int printf($untainted char *fmt, ...);

char *f3(char *s) { return s; }
char *f2(char *s) { return f3(s); }
char *f1(char *s) { return f2(s); }

int main(void)
{
  char *s, *unclean;

  unclean = getenv("PATH");

  s = f1(unclean);
  printf(s);
}
